(in-package :itc-v2/tests/internal)

(in-suite :itc-ncd-bfm)

;;; Make a few useful fixtures.

(defun negative-cycle-equal? (cycle1 cycle2)
  (not (and (set-difference cycle1 cycle2 :test #'equal)
            (set-difference cycle1 cycle2 :test #'equal))))

(def-fixture empty-stack ()
  (let ((*s* (make-queue :type :lifo)))
    (&body)))

(def-fixture empty-queue ()
  (let ((*q* (make-queue :type :fifo)))
    (&body)))

;; Tests

(def-test fill-and-empty-stack ()
  (let ((va (make-bfm-vertex :id 'a))
        (vb (make-bfm-vertex :id 'b))
        (vc (make-bfm-vertex :id 'c)))
    (with-fixture empty-stack ()
      (is (isempty? *s*) "A newly created stack was not empty.")
      (enqueue! *s* va)
      (enqueue! *s* vb)
      (enqueue! *s* vc)
      (is (eq vc (dequeue! *s*)) "Expected vertex c to be removed from stack.")
      (is (eq vb (dequeue! *s*)) "Expected vertex b to be removed from stack.")
      (is (eq va (dequeue! *s*)) "Expected vertex a to be removed from stack.")
      (is (isempty? *s*) "Stack was not empty after removing all vertices.")
      (is (eq nil (dequeue! *s*)) "Expected nil when removing from an empty stack.")
      (is (isempty? *s*) "Stack was not empty after removing more vertices than in the stack."))))

(def-test fill-and-empty-queue ()
  (let ((va (make-bfm-vertex :id 'a))
        (vb (make-bfm-vertex :id 'b))
        (vc (make-bfm-vertex :id 'c)))
    (with-fixture empty-queue ()
      (is (isempty? *q*)  "A newly created queue was not empty.")
      (enqueue! *q* va)
      (enqueue! *q* vb)
      (enqueue! *q* vc)
      (is (eq va (dequeue! *q*)) "Expected vertex a to be removed from queue.")
      (is (eq vb (dequeue! *q*)) "Expected vertex b to be removed from queue.")
      (is (eq vc (dequeue! *q*)) "Expected vertex c to be removed from queue.")
      (is (isempty? *q*) "Queue was not empty after removing all vertices.")
      (is (eq nil (dequeue! *q*)) "Expected nil when removing from an empty queue.")
      (is (isempty? *q*) "Queue was not empty after removing more vertices than in the queue."))))

(def-test repeated-add-to-stack ()
    (let ((va (make-bfm-vertex :id 'a))
          (vb (make-bfm-vertex :id 'b))
          (vc (make-bfm-vertex :id 'c)))
      (with-fixture empty-stack ()
        (is (isempty? *s*)  "A newly created stack was not empty.")
        (enqueue! *s* va)
        (enqueue! *s* vb)
        (enqueue! *s* va)
        (enqueue! *s* vc)
        (enqueue! *s* vc)
        (enqueue! *s* va)
        (is (eq vc (dequeue! *s*)) "Expected vertex a to be removed from stack.")
        (is (eq vb (dequeue! *s*)) "Expected vertex b to be removed from stack.")
        (is (eq va (dequeue! *s*)) "Expected vertex c to be removed from stack.")
        (is (isempty? *s*) "Stack was not empty after removing all vertices.")
        (is (eq nil (dequeue! *s*)) "Expected nil when removing from an empty stack.")
        (is (isempty? *s*) "Stack was not empty after removing more vertices than in the stack."))))

(def-test repeated-add-to-queue ()
    (let ((va (make-bfm-vertex :id 'a))
          (vb (make-bfm-vertex :id 'b))
          (vc (make-bfm-vertex :id 'c)))
      (with-fixture empty-queue ()
        (is (isempty? *q*)  "A newly created queue was not empty.")
        (enqueue! *q* va)
        (enqueue! *q* vb)
        (enqueue! *q* va)
        (enqueue! *q* vc)
        (enqueue! *q* vc)
        (enqueue! *q* va)
        (is (eq (in-set va) t) "Vertex a's flag indicates it is in the set, but it should be nil.")
        (is (eq (next-set-vertex va) vb) "Vertex a has a next-set-vertex, but it should be nil.")
        (is (eq (in-set vb) t) "Vertex b's flag indicates it is in the set, but it should be nil.")
        (is (eq (next-set-vertex vb) vc) "Vertex b has a next-set-vertex, but it should be nil.")
        (is (eq (in-set vc) t) "Vertex c's flag indicates it is in the set, but it should be nil.")
        ;; start dequeue
        (is (eq va (dequeue! *q*)) "Expected vertex a to be removed from queue.")
        (is (eq vb (dequeue! *q*)) "Expected vertex b to be removed from queue.")
        (is (eq vc (dequeue! *q*)) "Expected vertex c to be removed from queue.")
        (is (isempty? *q*) "Queue was not empty after removing all vertices.")
        (is (eq nil (dequeue! *q*)) "Expected nil when removing from an empty queue.")
        (is (isempty? *q*) "Queue was not empty after removing more vertices than in the queue."))))

(def-test empty-the-stack ()
    (let ((va (make-bfm-vertex :id 'a))
          (vb (make-bfm-vertex :id 'b))
          (vc (make-bfm-vertex :id 'c)))
      (with-fixture empty-stack ()
        (is (isempty? *s*)  "A newly created stack was not empty.")
        (enqueue! *s* va)
        (enqueue! *s* vb)
        (enqueue! *s* vc)
        (is (not (isempty? *s*))  "The stack should not be empty after having added three vertices.")
        (empty! *s*)
        (is (isempty? *s*) "The stack should be empty now, after the empty! function was called.")
        ;; check properties of the vertices
        (is (eq (in-set va) nil) "Vertex a's flag indicates it is in the set, but it should be nil.")
        (is (eq (next-set-vertex va) nil) "Vertex a has a next-set-vertex, but it should be nil.")
        (is (eq (in-set vb) nil) "Vertex b's flag indicates it is in the set, but it should be nil.")
        (is (eq (next-set-vertex vb) nil) "Vertex b has a next-set-vertex, but it should be nil.")
        (is (eq (in-set vc) nil) "Vertex c's flag indicates it is in the set, but it should be nil.")
        (is (eq (next-set-vertex vc) nil) "Vertex c has a next-set-vertex, but it should be nil.")
        ;; check that the stack is still functional
        (enqueue! *s* vc)
        (enqueue! *s* vb)
        (enqueue! *s* va)
        (is (eq va (dequeue! *s*)) "Expected vertex a to be removed from stack.")
        (is (eq vb (dequeue! *s*)) "Expected vertex b to be removed from stack.")
        (is (eq vc (dequeue! *s*)) "Expected vertex c to be removed from stack."))))

(def-test empty-the-queue ()
    (let ((va (make-bfm-vertex :id 'a))
          (vb (make-bfm-vertex :id 'b))
          (vc (make-bfm-vertex :id 'c)))
      (with-fixture empty-queue ()
        (is (isempty? *q*)  "A newly created queue was not empty.")
        (enqueue! *q* va)
        (enqueue! *q* vb)
        (enqueue! *q* vc)
        (is (not (isempty? *q*))  "The queue should not be empty after having added three vertices.")
        (empty! *q*)
        (is (isempty? *q*) "The queue should be empty now, after the empty! function was called.")
        ;; check properties of the vertices
        (is (eq (in-set va) nil) "Vertex a's flag indicates it is in the set, but it should be nil.")
        (is (eq (next-set-vertex va) nil) "Vertex a has a next-set-vertex, but it should be nil.")
        (is (eq (in-set vb) nil) "Vertex b's flag indicates it is in the set, but it should be nil.")
        (is (eq (next-set-vertex vb) nil) "Vertex b has a next-set-vertex, but it should be nil.")
        (is (eq (in-set vc) nil) "Vertex c's flag indicates it is in the set, but it should be nil.")
        (is (eq (next-set-vertex vc) nil) "Vertex c has a next-set-vertex, but it should be nil.")
        ;; check that the queue is still functional
        (enqueue! *q* vc)
        (enqueue! *q* vb)
        (enqueue! *q* va)
        (is (eq vc (dequeue! *q*)) "Expected vertex c to be removed from queue.")
        (is (eq vb (dequeue! *q*)) "Expected vertex b to be removed from queue.")
        (is (eq va (dequeue! *q*)) "Expected vertex a to be removed from queue."))))

(def-test lazy-removal-stack ()
  (let ((va (make-bfm-vertex :id 'a))
        (vb (make-bfm-vertex :id 'b))
        (vc (make-bfm-vertex :id 'c)))
    (with-fixture empty-stack ()
      ;; test that the first element can be lazily removed
      (enqueue! *s* va)
      (enqueue! *s* vb)
      (enqueue! *s* vc)
      (setf (in-set va) nil)
      (is (eq (isempty? *s*) nil) "The stack should not be empty after the first element was removed.")
      (is (eq vc (dequeue! *s*)) "Expected vertex c to be removed from stack.")
      (is (eq vb (dequeue! *s*)) "Expected vertex b to be removed from stack.")
      (is (eq (isempty? *s*) t) "The stack should be empty after the first element was lazily removed, but the other two were properly dequeued.")
      ;; test that the second element can be lazily removed
      (enqueue! *s* va)
      (enqueue! *s* vb)
      (enqueue! *s* vc)
      (setf (in-set vb) nil)
      (is (eq (isempty? *s*) nil) "The stack should not be empty after the second element was removed.")
      (is (eq vc (dequeue! *s*)) "Expected vertex c to be removed from stack.")
      (is (eq va (dequeue! *s*)) "Expected vertex a to be removed from stack.")
      (is (eq (isempty? *s*) t) "The stack should be empty after the second element was lazily removed, but the other two were properly dequeued.")
      ;; test that the third element can be lazily removed
      (enqueue! *s* va)
      (enqueue! *s* vb)
      (enqueue! *s* vc)
      (setf (in-set vc) nil)
      (is (eq (isempty? *s*) nil) "The stack should not be empty after the third element was removed.")
      (is (eq vb (dequeue! *s*)) "Expected vertex b to be removed from stack.")
      (is (eq va (dequeue! *s*)) "Expected vertex a to be removed from stack.")
      (is (eq (isempty? *s*) t) "The stack should be empty after the third element was lazily removed, but the other two were properly dequeued.")
      ;; test that all elements can be lazily removed
      (enqueue! *s* va)
      (enqueue! *s* vb)
      (enqueue! *s* vc)
      (setf (in-set va) nil)
      (setf (in-set vb) nil)
      (setf (in-set vc) nil)
      (is (eq (isempty? *s*) t) "The stack should be empty after the all elements were lazily removed."))))

(def-test lazy-removal-queue ()
  (let ((va (make-bfm-vertex :id 'a))
        (vb (make-bfm-vertex :id 'b))
        (vc (make-bfm-vertex :id 'c)))
    (with-fixture empty-queue ()
      ;; test that the first element can be lazily removed
      (enqueue! *q* va)
      (enqueue! *q* vb)
      (enqueue! *q* vc)
      (setf (in-set va) nil)
      (is (eq (isempty? *q*) nil) "The queue should not be empty after the first element was removed.")
      (is (eq vb (dequeue! *q*)) "Expected vertex b to be removed from queue.")
      (is (eq vc (dequeue! *q*)) "Expected vertex c to be removed from queue.")
      (is (eq (isempty? *q*) t) "The queue should be empty after the first element was lazily removed, but the other two were properly dequeued.")
      ;; test that the second element can be lazily removed
      (enqueue! *q* va)
      (enqueue! *q* vb)
      (enqueue! *q* vc)
      (setf (in-set vb) nil)
      (is (eq (isempty? *q*) nil) "The queue should not be empty after the second element was removed.")
      (is (eq va (dequeue! *q*)) "Expected vertex a to be removed from queue.")
      (is (eq vc (dequeue! *q*)) "Expected vertex c to be removed from queue.")
      (is (eq (isempty? *q*) t) "The queue should be empty after the second element was lazily removed, but the other two were properly dequeued.")
      ;; test that the third element can be lazily removed
      (enqueue! *q* va)
      (enqueue! *q* vb)
      (enqueue! *q* vc)
      (setf (in-set vc) nil)
      (is (eq (isempty? *q*) nil) "The queue should not be empty after the third element was removed.")
      (is (eq va (dequeue! *q*)) "Expected vertex a to be removed from queue.")
      (is (eq vb (dequeue! *q*)) "Expected vertex b to be removed from queue.")
      (is (eq (isempty? *q*) t) "The queue should be empty after the third element was lazily removed, but the other two were properly dequeued.")
      ;; test that all elements can be lazily removed
      (enqueue! *q* va)
      (enqueue! *q* vb)
      (enqueue! *q* vc)
      (setf (in-set va) nil)
      (setf (in-set vb) nil)
      (setf (in-set vc) nil)
      (is (eq (isempty? *q*) t) "The queue should be empty after the all elements were lazily removed."))))

;;; Tests on Circularly Linked Lists involving BFM vertices

(def-test set-child-cll ()
  (let ((vp (make-bfm-vertex :id 'parent))
        (va (make-bfm-vertex :id 'a))
        (vb (make-bfm-vertex :id 'b))
        (vc (make-bfm-vertex :id 'c)))
    (set-parent vp va)
    (set-parent vp vb)
    (set-parent vp vc)
    ;; check that the parent-child relationship is correct
    (is (debug-is-child vp va) "A is not a child of PARENT.")
    (is (not (debug-is-child va vp)) "PARENT is a child of A.")
    (is (debug-is-child vp vb) "B is not a child of PARENT.")
    (is (not (debug-is-child vb vp)) "PARENT is a child of B.")
    (is (debug-is-child vp vc) "C is not a child of PARENT.")
    (is (not (debug-is-child vc vp)) "PARENT is a child of C.")))

(def-test delete-subtree ()
  (let ((vp (make-bfm-vertex :id 'p))
        (va (make-bfm-vertex :id 'a)) ;; child of p (no children)
        (vb (make-bfm-vertex :id 'b)) ;; child of p (1 child)
        (vc (make-bfm-vertex :id 'c)) ;; child of p (2 children)
        (vd (make-bfm-vertex :id 'd)) ;; child of b
        (ve (make-bfm-vertex :id 'e)) ;; child of c
        (vf (make-bfm-vertex :id 'f)));; child of f
    (set-parent vp va)
    (set-parent vp vb)
    (set-parent vp vc)
    (set-parent vb vd)
    (set-parent vc ve)
    (set-parent vc vf)
    (delete-subtree va)
    (delete-subtree vb)
    (delete-subtree vc)
    ;; this test is not completely implemented
    (is (eq (child vp) nil) "The subtrees of P have been removed, so this node should have no children.")))

(def-test acyclic-shortest-path-1 ()
  (let ((g (make-bfm-graph)))
    (ensure-edge g 'a 'b :weight 1)
    (ensure-edge g 'a 'c :weight 9)
    (ensure-edge g 'b 'd :weight 3)
    (ensure-edge g 'c 'd :weight 1)
    (initialize g)
    (is (check-consistency g) "Graph:~% ~a~% is known to be consistent, but (check-consistency) said it was not." g)))


(def-test acyclic-shortest-path-2 ()
  (let ((g (make-bfm-graph)))
    (ensure-edge g 's 'a :weight 1)
    (ensure-edge g 's 'b :weight 9)
    (ensure-edge g 'a 'c :weight 3)
    (ensure-edge g 'a 'd :weight 1)
    (ensure-edge g 'b 'd :weight 1)
    (ensure-edge g 'b 'e :weight 2)
    (ensure-edge g 'c 'f :weight 2)
    (ensure-edge g 'd 'f :weight 7)
    (ensure-edge g 'd 'g :weight 8)
    (ensure-edge g 'e 'g :weight 3)
    (ensure-edge g 'f 't :weight 5)
    (ensure-edge g 'g 't :weight 2)
    (initialize g)
    (is (check-consistency g) "Graph:~% ~a~% is known to be consistent, but (check-consistency) said it was not." g)))

(def-test one-negative-cycle-1 ()
  (let ((g (make-bfm-graph)))
    (ensure-edge g 'a 'b :weight 1)
    (ensure-edge g 'b 'a :weight -2)
    (initialize g)
    (is (not (check-consistency g)) "Graph:~% ~a~% is known to have a negative cycle, but (check-consistency) said it was consistent." g)))

(def-test one-negative-cycle-2 ()
  (let ((g (make-bfm-graph)))
    (ensure-edge g 's 'a :weight 1)
    (ensure-edge g 's 'b :weight 9)
    (ensure-edge g 'a 'c :weight 3)
    (ensure-edge g 'a 'd :weight 1)
    (ensure-edge g 'b 'd :weight 1)
    (ensure-edge g 'b 'e :weight 2)
    (ensure-edge g 'c 'f :weight 2)
    (ensure-edge g 'd 'f :weight 7)
    (ensure-edge g 'd 'g :weight 8)
    (ensure-edge g 'e 'g :weight 3)
    (ensure-edge g 'f 't :weight 5)
    (ensure-edge g 'g 't :weight 2)
    ;; add a negative cycle (the actual shortest length path is 11)
    (ensure-edge g 't 's :weight -12)
    (initialize g)
    (is (not (check-consistency g)) "Graph:~% ~a~% is known to have a negative cycle, but (check-consistency) said it was consistent." g)))

(def-test multiple-negative-cycle-1 ()
  (let ((g (make-bfm-graph)))
    (ensure-edge g 's 'a :weight 1)
    (ensure-edge g 's 'b :weight 9)
    (ensure-edge g 'a 'c :weight 3)
    (ensure-edge g 'a 'd :weight 1)
    (ensure-edge g 'b 'd :weight 1)
    (ensure-edge g 'b 'e :weight 2)
    (ensure-edge g 'c 'f :weight 2)
    (ensure-edge g 'd 'f :weight 7)
    (ensure-edge g 'd 'g :weight 8)
    (ensure-edge g 'e 'g :weight 3)
    (ensure-edge g 'f 't :weight 5)
    (ensure-edge g 'g 't :weight 2)
    ;; add a negative cycle (the actual shortest length path is t to s is 11)
    (ensure-edge g 't 's :weight -12)
    (initialize g)
    (multiple-value-bind (consistent? neg-cycle)
        (check-consistency g)
      (is (not consistent?) "Graph v1:~% ~a~% is known to have a negative cycle, but (check-consistency) said it was consistent." g)
      ;; (format t "NEGATIVE-CYCLE 1: ~a~%" neg-cycle)
      (is (negative-cycle-equal? neg-cycle '((T S) (S A) (A C) (C F) (F T)))))
    ;; make the previous negative cycle marginal
    (ensure-edge g 't 's :weight -11)
    ;; add another negative cycle (the actual shortest length path is g to s is 14)
    (ensure-edge g 'g 's :weight -15)
    (initialize g)
    (multiple-value-bind (consistent? neg-cycle)
        (check-consistency g)
      (is (not consistent?) "Graph v2:~% ~a~% is known to have a negative cycle, but (check-consistency) said it was consistent." g)
      ;; (format t "NEGATIVE-CYCLE 2: ~a~%" neg-cycle)
      (is (negative-cycle-equal? neg-cycle '((G S) (S A) (A D) (D G)))))

    ;; add another negative cycle (two total)
    ;; (the actual shortest length path from g to a is 9)
    (ensure-edge g 'g 'a :weight -8)
    (initialize g)
    (multiple-value-bind (consistent? neg-cycle)
        (check-consistency g)
      (is (not consistent?) "Graph v3:~% ~a~% is known to have a negative cycle, but (check-consistency) said it was consistent." g)
      ;; (format t "NEGATIVE-CYCLE 3: ~a~%" neg-cycle)
      (is (negative-cycle-equal? neg-cycle '((G S) (S A) (A D) (D G)))))))


(def-test shortest-distance-and-path ()
  (let ((g (make-bfm-graph :start-vertex-id 's)))
    (ensure-edge g 's 'a :weight 1)
    (ensure-edge g 's 'b :weight 9)
    (ensure-edge g 'a 'c :weight 3)
    (ensure-edge g 'a 'd :weight 1)
    (ensure-edge g 'b 'd :weight 1)
    (ensure-edge g 'b 'e :weight 2)
    (ensure-edge g 'c 'f :weight 2)
    (ensure-edge g 'd 'f :weight 7)
    (ensure-edge g 'd 'g :weight 8)
    (ensure-edge g 'e 'g :weight 3)
    (ensure-edge g 'f 't :weight 5)
    (ensure-edge g 'g 't :weight 2)
    ;; initialize the graph and make sure it is consistent
    (initialize g)
    (check-consistency g)
    ;; distance check
    (is (= (distance g 't) 11) "The expected shortest distance is 11.")
    ;; path check
    (is (equal (mapcar #'id (path g 't)) '(s a c f t)) "The expected shortest path is through vertices S A C F T.")))

(def-test change-start-vertex ()
  (let ((g (make-bfm-graph :start-vertex-id 's)))
    (ensure-edge g 's 'a :weight 1)
    (ensure-edge g 's 'b :weight 9)
    (ensure-edge g 'a 'c :weight 3)
    (ensure-edge g 'a 'd :weight 1)
    (ensure-edge g 'b 'd :weight 1)
    (ensure-edge g 'b 'e :weight 2)
    (ensure-edge g 'c 'f :weight 2)
    (ensure-edge g 'd 'f :weight 7)
    (ensure-edge g 'd 'g :weight 8)
    (ensure-edge g 'e 'g :weight 3)
    (ensure-edge g 'f 't :weight 5)
    (ensure-edge g 'g 't :weight 2)
    ;; initialize the graph and make sure it is consistent
    (initialize g)
    (check-consistency g)
    ;; distance check
    (is (= (distance g 't) 11) "The expected shortest distance is 11.")
    ;; path check
    (is (equal (mapcar #'id (path g 't)) '(s a c f t)) "The expected shortest path is through vertices S A C F T.")
    ;; change start vertex

    (change-start-vertex g 'a)
    (initialize g)
    (check-consistency g)
    ;; distance check
    (is (= (distance g 't) 10) "The expected shortest distance is 10.")
    ;; path check
    (is (equal (mapcar #'id (path g 't)) '(a c f t)) "The expected shortest path is through vertices A C F T.")))
